<?php
	// Загрузка настроек
	$db->Query("SELECT * FROM shp_megaconf WHERE id =  '1'");
	$mconf = $db->FetchArray();
	// проверка IP-адреса
	$ip_checked = false;

	foreach(array(
		'HTTP_X_CLUSTER_CLIENT_IP',
		'HTTP_X_FORWARDED_FOR',
		'HTTP_X_FORWARDED',
		'HTTP_FORWARDED_FOR',
		'HTTP_FORWARDED',
		'HTTP_CLIENT_IP',
		'REMOTE_ADDR'
	) as $param) {
		if(!empty($_SERVER[$param]) && $_SERVER[$param] === '5.196.121.217') {
			$ip_checked = true;
			break;
		}
	}
	if(!$ip_checked) {
		die('error');
	}

	// проверка на наличие обязательных полей
	// поля $payment_time и $debug могут дать true для empty() поэтому их нет в проверке
	foreach(array(
		'uid',
		'amount',
		'amount_shop',
		'amount_client',
		'currency',
		'order_id',
		'payment_method_id',
		'payment_method_title',
		'creation_time',
		'client_email',
		'status',
		'signature'
	) as $field) {
		if(empty($_REQUEST[$field])) {
			die('error');
		}
	}

	// ваш секретный ключ
	$secret_key	= $mconf['secret_key'];

	// нормализация данных
	$uid					= (int)$_REQUEST["uid"];
	$amount					= (double)$_REQUEST["amount"];
	$amount_shop			= (double)$_REQUEST["amount_shop"];
	$amount_client			= (double)$_REQUEST["amount_client"];
	$currency				= $_REQUEST["currency"];
	$order_id				= $_REQUEST["order_id"];
	$payment_method_id		= (int)$_REQUEST["payment_method_id"];
	$payment_method_title	= $_REQUEST["payment_method_title"];
	$creation_time			= $_REQUEST["creation_time"];
	$payment_time			= $_REQUEST["payment_time"];
	$client_email			= $_REQUEST["client_email"];
	$status					= $_REQUEST["status"];
	$debug					= (!empty($_REQUEST["debug"])) ? '1' : '0';
	$signature				= $_REQUEST["signature"];

	// проверка валюты
	if(!in_array($currency, array('RUB', 'USD', 'EUR'), true)) {
		die('error');
	}

	// проверка статуса платежа
	if(!in_array($status, array('success', 'fail'), true)) {
		die('error');
	}

	// проверка формата сигнатуры
	if(!preg_match('/^[0-9a-f]{32}$/', $signature)) {
		die('error');
	}

	// проверка значения сигнатуры
	$signature_calc = md5(join(':', array(
		$uid, $amount, $amount_shop, $amount_client, $currency, $order_id,
		$payment_method_id, $payment_method_title, $creation_time, $payment_time,
		$client_email, $status, $debug, $secret_key
	)));
	if($signature_calc !== $signature) {
		die('error');
	}

	$db->Query("SELECT * FROM shp_orders WHERE id = '{$order_id}'");
	if ($db->NumRows() > 0) {
		$order_data = $db->FetchArray();
	}else die('error');

	// check_status
	if ($order_data['status'] > 1) die('ok');

	// обработка платежа
	switch($status) {
		case 'success':

			// время соверешния платежа в Unix timestamp (если нужно)
			$payment_time_ts = strtotime($payment_time);

			// set_status
			$db->Query("UPDATE shp_orders SET status = '2', date_check_order = '{$payment_time_ts}' WHERE id = '{$order_id}'");

			// get_product_data
			$db->Query("SELECT * FROM shp_products WHERE id = '{$order_data['product_id']}'");
			$product_data = $db->FetchArray();

			// get_author_data
			$db->Query("SELECT * FROM shp_accounts WHERE id = '{$product_data['author_id']}'");
			$author_data = $db->FetchArray();

			// buy_process
			$author_id = $author_data['id'];
			$money = $order_data['price']*0.80;
			$db->Query("UPDATE shp_accounts SET balance = balance + $money WHERE id = '{$author_id}'");
			$db->Query("UPDATE shp_products SET count_sells = count_sells + 1 WHERE id = '{$product_data['id']}'");

			// ref_process
			if ($author_data['refer'] != '0'){
				$ref_money = func::clearFloat($order_data['price'] * 0.05);
				$db->Query("UPDATE shp_accounts SET balance = balance + $ref_money WHERE id = '{$author_data['referer']}'");
				$db->Query("UPDATE shp_accounts SET to_ref = to_ref + $ref_money,last_to_ref = '{$time}' WHERE id = '{$product_data['author_id']}'");
			}

			// mail_process
			$link = 'http://'.$_SERVER['HTTP_HOST'].'/download/'.$order_data['download_key'];
			$email = $order_data['user_email'];
			$mail = new mail();
			$mail->sendBuyLink($email,$link);
			break;
		case 'fail':
			// set_status
			$db->Query("UPDATE shp_orders SET status = '3' WHERE id = '{$order_id}'");
			break;
	}

	// успешный ответ для Мегакассы и завершение скрипта
	die('ok');
?>
