var acc;
acc = {
	init: function () {
		$('.btn-file.poster').each(function (){
			var self = this;
			$('input[type=file]', this).change(function (){
				$(self).next().remove();
				var value = $(this).val();
				$('<span> '+value+'</span>').insertAfter(self);
				acc.uploadPoster();
			});
		});
		$('.btn-file.file').each(function (){
			var self = this;
			$('input[type=file]', this).change(function (){
				$(self).next().remove();
				var value = $(this).val();
				$('<span> '+value+'</span>').insertAfter(self);
				acc.uploadFile();
			});
		});
	},
	formCtrl: function (res,form) {
		var type = form.find('input[name=account]').val();
		switch (type) {
			case 'add': acc.addCtrl(res); break;
			case 'edit': acc.editCtrl(res); break;
			case 'delete': acc.deleteCtrl(res); break;
			case 'up': acc.deleteCtrl(res); break;
			case 'settings': acc.reloadCtrl(res); break;
			case 'ticket': acc.reloadCtrl(res); break;
			case 'payment': acc.paymentCtrl(res); break;
			default: app.errorsController('Ошибка, обновите страницу'); break;
		}
	},
	uploadPoster: function() {
		var form = $(document).find('#posterUpload'),
			fd = new FormData(document.getElementById('posterUpload'));
		$.ajax({
			url: "/api",
			type: "POST",
			data: fd,
			enctype: 'multipart/form-data',
			processData: false,
			contentType: false,
			beforeSend: function () {
				$('.btn-file.poster > span').html('<i class="fa fa-refresh fa-spin"></i>');
			},
			success: function (data) {
				$('.btn-file.poster > span').html('Выберите изображение...');
				var res = $.parseJSON(data);
				if (res.status === 'success') {
					$('#preview-img').attr('src','/img/posters/' + res.text);
					$('input[name=poster]').val(res.text);
					app.errorsController('Изображение загружено');
				}else {
					app.errorsController(res.text);
				}
			}
		});
	},
	uploadFile: function() {
		var form = $(document).find('#fileUpload'),
			fd = new FormData(document.getElementById('fileUpload'));
		$.ajax({
			url: "/api",
			type: "POST",
			data: fd,
			enctype: 'multipart/form-data',
			processData: false,
			contentType: false,
			beforeSend: function () {
				$('.btn-file.file > span').html('<i class="fa fa-refresh fa-spin"></i>');
			},
			success: function (data) {
				$('.btn-file.file > span').html('Выберите файл...');
				var res = $.parseJSON(data);
				if (res.status === 'success') {
					$('input[name=file]').val(res.text);
					app.errorsController('Файл загружен');
				}else {
					app.errorsController(res.text);
				}
			}
		});
	},
	addCtrl: function (res) {
		app.errorsController(res.text);
		if (res.status === 'success') {
			setTimeout(function(){
				window.location.href = '/account/products';
			},1000);
		}
	},
	editCtrl: function (res) {
		app.errorsController(res.text);
		if (res.status === 'success') {
			setTimeout(function(){
				window.location.href = '/account/products';
			},1000);
		}
	},
	reloadCtrl: function (res) {
		app.errorsController(res.text);
		if (res.status === 'success') {
			setTimeout(function(){
				window.location.reload();
			},1000);
		}
	},
	paymentCtrl: function (res) {
		app.errorsController(res.text);
		if (res.status === 'success') {
			$('input[name=money]').val('');
		}
	},
	addReloader: function () {
		setInterval(function () {
			var title = $('input[name=title]').val(),
				title = (title.length > 30) ? title.substr(0,30).trim() + '..' : title,
				price = parseInt($('input[name=price]').val()),
				price = (price.toString() == 'NaN') ? 0 : price,
				price = price + ' <i class="fa fa-rub"></i>';
			$('#preview-title').text(title);
			$('#preview-price').html(price);
		},500);
	},
	deleteCtrl: function (res) {
		app.errorsController(res.text);
		if (res.status === 'success') {
			setTimeout(function(){
				window.location.href = '/account/products';
			},1000);
		}
	},
	deleteProduct: function (id) {
		var mWindow = $('#deleteModal');
		mWindow.find('input[name=id]').val(id);
		mWindow.modal('show');
	},
	upProduct: function (id) {
		var mWindow = $('#upProductModal');
		mWindow.find('input[name=id]').val(id);
		mWindow.modal('show');
	},
	startProduct: function (id) {
		$.ajax({
			url: "/api",
			type: "POST",
			data: {
				'api': 'account',
				'account': 'start',
				'id': id,
			},
			success: function (data) {
				var res = $.parseJSON(data);
				if (res.status === 'success') {
					var btnIcon = (res.text == '2') ? '<i class="fa fa-stop"></i>' : '<i class="fa fa-play"></i>',
						titleTxt = (res.text == '2') ? 'Остановить продажи' : 'Запустить продажи',
						alertText = (res.text == '2') ? 'Продажи запущены' : 'Продажи остановлены';
					$('button[product-id='+id+']')
						.html(btnIcon)
						.attr('title',titleTxt);
					app.errorsController(alertText);
				}else {
					app.errorsController(res.text);
				}
			}
		});
	}
}
acc.init();
