var app;
app = {
	init: function() {
		$('body').on('submit', 'form', app.submitForm);
		$('form').on('keydown', '.input-group', app.removeError);
		$('[data-toggle="popover"]').popover();
	},
	errorsController: function (text) {
		var randSym = (Math.random() * (999999 - 111111) + 111111).toFixed(0),
			errBlock = '<div class="message" id="msg'+randSym+'">'+text+'</div>';
		$('#messages').append(errBlock);
		setTimeout(function () {
			$('#msg'+randSym).fadeOut(600,function () {
				$('#msg'+randSym).remove();
			});
		},3000);
	},
	removeError: function() {
		$(this).tooltip('destroy').parents('.form-group').removeClass('has-error');
	},
	submitForm: function (e) {
		var form = $(this);
		if (form.attr('act') !== '1'){
			e.preventDefault();
			var submitBtn = form.find('button');
			if(app.validForm(form) === false) return false;
			var str = form.serialize(),
				type = form.find('input[name=api]').val();
			submitBtn.attr('disabled','disable');
			$.ajax({
				url: "/api",
				type: "POST",
				data: str,
				success: function(data){
					var res = $.parseJSON(data);
					switch(type){
						case 'auth': app.authCtrl(res); break;
						case 'recovery': app.recoveryCtrl(res); break;
						case 'buy': app.buyCtrl(res); break;
						case 'contact': app.contactCtrl(res); break;
						case 'reg': app.regCtrl(res); break;
						case 'account': acc.formCtrl(res,form); break;
						case 'review': app.reviewCtrl(res); break;
						default: app.errorsController('Ошибка, обновите страницу'); break;
					}
					setTimeout(function() {
						submitBtn.removeAttr('disabled');
					},200);
				},
				error: function () {
					app.connectError();
				}
			});
		}
	},
	validForm: function (form) {
		var inputs = form.find('input'),
			valid = true;
		inputs.tooltip('destroy');
		$.each(inputs, function(index, val) {
			var input = $(val),
				val = input.val(),
				formGroup = input.parents('.form-group'),
				inputGroup = formGroup.find('.input-group'),
				textError = 'Заполните поле';
			if(val.length === 0){
				formGroup.addClass('has-error');
				inputGroup.tooltip({
					trigger: 'manual',
					placement: 'auto top',
					title: textError
				}).tooltip('show');
				valid = false;
			}else {
				formGroup.removeClass('has-error').addClass('has-success');
				inputGroup.tooltip('hide');
			}
		});
		return valid;
	},
	authCtrl: function (res) {
		if (res.status === 'success') {
			window.location.reload();
		}else {
			grecaptcha.reset(authBlock);
			app.errorsController(res.text);
		}
	},
	reviewCtrl: function (res) {
		app.errorsController(res.text);
		if (res.status === 'success') {
			setTimeout(function () {
				window.location.reload();
			},1000);
		}
	},
	recoveryCtrl: function (res) {
		app.errorsController(res.text);
		if (res.status == 'err') {
			grecaptcha.reset(recoveryBlock);
		}
	},
	regCtrl: function (res) {
		if (res.status === 'success') {
			window.location = '/account';
		}else {
			grecaptcha.reset(regBlock);
			app.errorsController(res.text);
		}
	},
	buyProduct: function (id) {
		var buyModal = $('#buyModal');
		buyModal.find('input[name=id]').val(id);
		buyModal.modal('show');
	},
	buyCtrl: function (res) {
		if (res.status === 'success') {
			var buyModal = $('#buyModal'),
				buyBtn = '<a href="'+res.text+'" class="btn btn-primary btn-block btn-lg">Перейти к оплате</a>';
			buyModal.find('#buyView').html(buyBtn);
		}else {
			app.errorsController(res.text);
		}
	},
	contactCtrl: function (res) {
		app.errorsController(res.text);
		if (res.status === 'success') {
			$('input[name=email]').val('');
			$('textarea[name=message]').val('');
		}
	},
	showFastView: function (id,title,about,price,img) {
		var modalWindow = $('#fastViewModal');
		modalWindow.find('.modal-title').html(title);
		modalWindow.find('#image-product').attr('src','/img/posters/'+img);
		modalWindow.find('#link-product').attr('href','/buy/'+id);
		modalWindow.find('#title-product').html(title);
		modalWindow.find('#about-product').html(about);
		modalWindow.find('#price-product').html(price + ' <i class="fa fa-rub"></i>');
		modalWindow.modal('show');
	},
	imgView: function (img) {
		$('#imgViewModal').find('#img-place').attr('src',img);
		$('#imgViewModal').modal('show');
	}
}
app.init();
$('#tick_msgs').perfectScrollbar();
