var admin;
admin = {
	mainCtrl: function (res,form) {
		var type = form.find('input[name=admin]').val();
		switch (type) {
			case 'edit_product': admin.editCtrl(res); break;
			case 'delete_product': admin.reloadCtrl(res); break;
			case 'ticket': admin.reloadCtrl(res); break;
			case 'settings': admin.settingsCtrl(res); break;
			case 'moderation': admin.moderationCtrl(res); break;
			case 'unmoderation': admin.moderationCtrl(res); break;
			default: app.errorsController('Ошибка, обновите страницу'); break;
		}
	},
	startProduct: function (id) {
		$.ajax({
			url: "/api",
			type: "POST",
			data: {
				api: 'admin',
				admin: 'start_product',
				id: id
			},
			success: function (data) {
				var res = $.parseJSON(data);
				if (res.status === 'success') {
					var icon = (res.text === '1') ? 'play' : 'stop',
						text = (res.text === '1') ? 'Запустить продажи' : 'Остановить продажи',
						resText = (res.text === '1') ? 'Продажи остановлены' : 'Продажи запущены';
					$('button[start-id='+id+']')
						.html('<i class="fa fa-'+icon+'"></i>')
						.attr('title',text);
					app.errorsController(resText);
				}else {
					app.errorsController(res.text);
				}
			}
		});
	},
	addReloader: function () {
		setInterval(function () {
			var title = $('input[name=title]').val(),
				title = (title.length > 30) ? title.substr(0,30).trim() + '..' : title,
				price = parseInt($('input[name=price]').val()),
				price = (price.toString() == 'NaN') ? 0 : price,
				price = price + ' <i class="fa fa-rub"></i>';
			$('#preview-title').text(title);
			$('#preview-price').html(price);
		},500);
	},
	deleteProduct: function (id) {
		var deleteModal = $('#deleteModal');
		deleteModal.find('input[name=id]').val(id);
		deleteModal.modal('show');
	},
	reloadCtrl: function (res) {
		app.errorsController(res.text);
		if (res.status === 'success') {
			setTimeout(function () {
				window.location.reload();
			},500);
		}
	},
	settingsCtrl: function (res) {
		app.errorsController(res.text);
	},
	moderationCtrl: function (res) {
		app.errorsController(res.text);
		if (res.status === 'success') {
			setTimeout(function () {
				window.close();
			},2000);
		}
	},
	editCtrl: function (res) {
		app.errorsController(res.text);
		if (res.status === 'success') {
			setTimeout(function () {
				window.location = '/cpanel/products';
			},500);
		}
	},
	ban: function (id) {
		$.ajax({
			url: "/api",
			type: "POST",
			data: {
				api: 'admin',
				admin: 'ban_user',
				id: id
			},
			success: function (data) {
				var res = $.parseJSON(data);
				if (res.status === 'success') {
					var text = (res.text === '0') ? 'Забанить' : 'Разбанить',
						resText = (res.text === '0') ? 'Пользователь разбанен' : 'Пользователь забанен';
					$('button[data-ban='+id+']').html(text);
					app.errorsController(resText);
				}else {
					app.errorsController(res.text);
				}
			}
		});
	},
	payment: function (type,id) {
		$.ajax({
			url: "/api",
			type: "POST",
			data: {
				api: 'admin',
				admin: 'payment',
				type: type,
				id: id
			},
			success: function (data) {
				var res = $.parseJSON(data);
				app.errorsController(res.text);
				if (res.status === 'success') {
					$('tr[data-pay='+id+']').remove();
					setTimeout(function () {
						window.location.reload();
					},500);
				}
			}
		});
	},
	unmoderation: function (id) {
		var modalWindow = $('#unmoderationModal');
		modalWindow.find('input[name=id]').val(id);
		modalWindow.modal('show');
	},
	review: function(type,id) {
		$.ajax({
			url: "/api",
			type: "POST",
			data: {
				api: 'admin',
				admin: 'review',
				type: type,
				id: id
			},
			success: function (data) {
				var res = $.parseJSON(data);
				admin.reloadCtrl(res);
			}
		});
	}
}
