var app;
app = {
	init: function () {
		$('body').on('submit', 'form', app.submitForm);
		$('form').on('keydown', '.input-group', app.removeError);
	},
	errorsController: function (text) {
		var randSym = (Math.random() * (999999 - 111111) + 111111).toFixed(0),
			errBlock = '<div class="message" id="msg'+randSym+'">'+text+'</div>';
		$('#messages').append(errBlock);
		setTimeout(function () {
			$('#msg'+randSym).fadeOut(600,function () {
				$('#msg'+randSym).remove();
			});
		},3000);
	},
	removeError: function() {
		$(this).tooltip('destroy').parents('.form-group').removeClass('has-error');
	},
	submitForm: function (e) {
		var form = $(this);
		if (form.attr('act') !== '1'){
			e.preventDefault();
			var submitBtn = form.find('button');
			if(app.validForm(form) === false) return false;
			var str = form.serialize(),
				type = form.find('input[name=api]').val();
			submitBtn.attr('disabled','disable');
			$.ajax({
				url: "/api",
				type: "POST",
				data: str,
				success: function(data){
					var res = $.parseJSON(data);
					switch(type){
						case 'admin_auth': app.authCtrl(res); break;
						case 'admin': admin.mainCtrl(res,form); break;
						default: app.errorsController('Ошибка, обновите страницу'); break;
					}
					setTimeout(function() {
						submitBtn.removeAttr('disabled');
					},200);
				},
				error: function () {
					app.connectError();
				}
			});
		}
	},
	validForm: function (form) {
		var inputs = form.find('input'),
			valid = true;
		inputs.tooltip('destroy');
		$.each(inputs, function(index, val) {
			var input = $(val),
				val = input.val(),
				formGroup = input.parents('.form-group'),
				inputGroup = formGroup.find('.input-group'),
				textError = 'Заполните поле';
			if(val.length === 0){
				formGroup.addClass('has-error');
				inputGroup.tooltip({
					trigger: 'manual',
					placement: 'auto top',
					title: textError
				}).tooltip('show');
				valid = false;
			}else {
				formGroup.removeClass('has-error').addClass('has-success');
				inputGroup.tooltip('hide');
			}
		});
		return valid;
	},
	authCtrl: function (res) {
		app.errorsController(res.text);
		if (res.status === 'success') {
			window.location.reload();
		}
	},
}

app.init();
