<?php
$_OPT['title'] = 'Товары';
?>
<div class="container">
	<div class="col-md-2">
		<?php include 'views/layouts/leftmenu.php'; ?>
	</div>
	<div class="col-md-10">
		<div class="panel panel-shop">
			<div class="panel-body">
				<?php
				if ($data['products'] != '0') {
					foreach ($data['products'] as $product) {
						$play_btn = ($product['status'] == '1') ? 'Запустить продажи' : 'Остановить продажи';
						$play_btn_icon = ($product['status'] == '1') ? 'play' : 'stop';
						$moderation = ($product['moderation'] == '2') ? true : false;
						?>
						<div class="col-md-4 col-sm-6 col-xs-12">
							<div class="panel panel-product">
								<div class="panel-image">
									<img src="/img/posters/<?=$product['poster'];?>">
								</div>
								<div class="panel-body">
									<p style="white-space: nowrap;text-overflow: ellipsis;overflow: hidden;">
										<?=$product['title'];?>
									</p>
									<div class="about-block">
										Цена:
										<span class="label label-primary" style="float: right;font-size: 12px;"><?=$product['price'];?> <i class="fa fa-rub"></i></span>
									</div>
									<div class="about-block">
										Продаж:
										<span class="label label-primary" style="float: right;font-size: 12px;"><?=$product['count_sells'];?> <i class="fa fa-cube"></i></span>
									</div>
									<div class="about-block">
										Просмотров:
										<span class="label label-primary" style="float: right;font-size: 12px;"><?=$product['count_views'];?> <i class="fa fa-eye"></i></span>
									</div>
								</div>
								<div class="panel-footer">
									<?php
									if ($product['moderation'] == '2') {
										?>
										<button product-id="<?=$product['id'];?>"
												class="btn btn-primary"
												onclick="acc.startProduct(<?=$product['id'];?>);" title="<?=$play_btn;?>">
											<i class="fa fa-<?=$play_btn_icon;?>"></i>
										</button>
										<a class="btn btn-warning" href="/account/edit/<?=$product['id'];?>" title="Редактировать товар">
											<i class="fa fa-pencil"></i>
										</a>
										<button class="btn btn-info"
												onclick="acc.upProduct(<?=$product['id'];?>);" title="Поднять товар в списке">
											<i class="fa fa-arrow-up"></i>
										</button>
										<button class="btn btn-danger"
												onclick="acc.deleteProduct(<?=$product['id'];?>);" title="Удалить товар">
											<i class="fa fa-trash"></i>
										</button>
										<?php
									}else if ($product['moderation'] == '1') {
										echo '<button class="btn btn-block btn-default" disabled>Модерация...</button>';
									}else if ($product['moderation'] == '3') {
										?>
											<button class="btn btn-default btn-block" disabled>В публикации отказано</button>
											<br>
											<a class="btn btn-warning"
												href="/account/edit/<?=$product['id'];?>" title="Редактировать товар">
												<i class="fa fa-pencil"></i>
											</a>
											<button class="btn btn-danger"
													onclick="acc.deleteProduct(<?=$product['id'];?>);" title="Удалить товар">
												<i class="fa fa-trash"></i>
											</button>
											<button class="btn btn-default"
													data-toggle="popover"
													data-placement="right"
													data-content="<?=$product['reason'];?>">
												Причина отказа
											</button>
										<?php
									}
									?>
								</div>
							</div>
						</div>
						<?php
					}
				}
				?>
				<div class="col-md-4 col-sm-6 col-xs-12">
					<div class="panel panel-product">
						<div class="panel-addnew">
							<i class="fa fa-plus"></i>
						</div>
						<div class="panel-footer">
							<a href="/account/add" class="btn btn-primary btn-block">Добавить новый товар</a>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<!-- deleteModal -->
<div class="modal fade" id="deleteModal">
	<div class="modal-dialog">
		<div class="col-md-10 col-md-offset-1">
			<div class="modal-content">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal" aria-hidden="true"><i class="fa fa-close"></i></button>
					<h4 class="modal-title">Вы уверены?</h4>
				</div>
				<div class="modal-body">
					<center>
						<h4>Нажимая кнопку удалить, вы безвозвратно сотрете всю информацию о товаре!</h4>
					</center>
					<br>
					<form>
						<input type="hidden" name="api" value="account">
						<input type="hidden" name="account" value="delete">
						<input type="hidden" name="id" value="none">
						<button class="btn btn-danger btn-block">Удалить</button>
					</form>
				</div>
			</div>
		</div>
	</div>
</div>
<!-- upProductModal -->
<div class="modal fade" id="upProductModal">
	<div class="modal-dialog">
		<div class="col-md-10 col-md-offset-1">
			<div class="modal-content">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal" aria-hidden="true"><i class="fa fa-close"></i></button>
					<h4 class="modal-title">Поднятие товара в списке</h4>
				</div>
				<div class="modal-body">
					<center>
						<h4>Стоимость поднятия 20 <i class="fa fa-rub"></i>, эта сумма моментально спишется с вашего счета!</h4>
					</center>
					<br>
					<form>
						<input type="hidden" name="api" value="account">
						<input type="hidden" name="account" value="up">
						<input type="hidden" name="id" value="none">
						<button class="btn btn-info btn-block">Поднять товар в списке</button>
					</form>
				</div>
			</div>
		</div>
	</div>
</div>
