<?php
$_OPT['title'] = 'Товары';
?>
<div class="container">
	<div class="col-md-2">
		<?php include 'views/layouts/admin.leftmenu.php'; ?>
	</div>
	<div class="col-md-10">
		<div class="panel panel-shop">
			<div class="panel-body">
				<div class="col-md-12">
					<ul class="navbar nav nav-pills">
						<li <?=($data['button'] == 'all') ? 'class="active"' : '';?>><a href="/cpanel/products">Все товары</a></li>
						<li <?=($data['button'] == 'scripts') ? ' class="active"' : '';?>><a href="/cpanel/products/scripts">Скрипты</a></li>
						<li <?=($data['button'] == 'lendings') ? ' class="active"' : '';?>><a href="/cpanel/products/lendings">Лендинги</a></li>
						<li <?=($data['button'] == 'layouts') ? ' class="active"' : '';?>><a href="/cpanel/products/layouts">Шаблоны</a></li>
						<li <?=($data['button'] == 'infoproducts') ? ' class="active"' : '';?>>
							<a href="/cpanel/products/infoproducts">Инфотовары</a>
						</li>
						<li <?=($data['button'] == 'modules') ? ' class="active"' : '';?>><a href="/cpanel/products/modules">Модули</a></li>
						<li <?=($data['button'] == 'other') ? ' class="active"' : '';?>><a href="/cpanel/products/other">Разное</a></li>
					</ul>
					<div class="form-group">
						<form act="1">
							<div class="input-group">
								<input type="text" name="search" value="<?=$data['search'];?>" placeholder="Поиск товара" class="form-control">
								<div class="input-group-btn">
									<button class="btn btn-primary">Найти</button>
								</div>
							</div>
						</form>
					</div>
				</div>
				<?php
				if ($data['products'] != '0') {
					foreach ($data['products'] as $product) {
						$title = (strlen($product['title']) > 18) ? trim(mb_substr($product['title'], 0,18)).'..' : $product['title'];
						$title = preg_replace("/(".$data['search'].")/iu", '<font color="#428bca">\\1</font>', $title);
						$category_arr = array(
							'scripts'=>'Скрипты','lendings'=>'Лендинги','layouts'=>'Шаблоны',
							'infoproducts'=>'Инфотовары','modules'=>'Модули','other'=>'Разное');
						$category = $category_arr[$product['category']];
						$start_icon = ($product['status'] == '1') ? 'play' : 'stop';
						$start_title = ($product['status'] === '1') ? 'Запустить продажи' : 'Остановить продажи';
						?>
						<div class="col-md-4 col-sm-6 col-xs-12">
							<div class="panel panel-product">
								<div class="panel-image">
									<img src="/img/posters/<?=$product['poster'];?>">
								</div>
								<div class="panel-body">
									<?=$title;?>
									<div class="about-block">
										Цена:
										<span class="label label-primary" style="float: right;font-size: 12px;"><?=$product['price'];?> <i class="fa fa-rub"></i></span>
									</div>
									<div class="about-block">
										Автор:
										<a href="/cpanel/products?author=<?=$product['author_nickname'];?>" class="label label-primary" style="float: right;font-size: 12px;">
											<?=$product['author_nickname'];?>
										</a>
									</div>
									<div class="about-block">
										Категория:
										<a href="/cpanel/products/<?=$product['category'];?>" class="label label-primary" style="float: right;font-size: 12px;">
											<?=$category;?> <i class="fa fa-tag"></i>
										</a>
									</div>
									<div class="about-block">
										Продаж:
										<span class="label label-primary" style="float: right;font-size: 12px;"><?=$product['count_sells'];?> <i class="fa fa-cube"></i></span>
									</div>
									
									<div class="about-block">
										Просмотров:
										<span class="label label-primary" style="float: right;font-size: 12px;"><?=$product['count_views'];?> <i class="fa fa-eye"></i></span>
									</div>
								</div>
								<div class="panel-footer">
									<a href="/cpanel/view/<?=$product['id'];?>" target="_blank" class="btn btn-primary btn-block">Подробнее..</a>
									<div class="btn-group btn-block" style="margin-top:5px;">
										<button start-id="<?=$product['id'];?>"
												class="btn btn-primary btn-3block"
												onclick="admin.startProduct(<?=$product['id'];?>);"
												title="<?=$start_title;?>">
											<i class="fa fa-<?=$start_icon;?>"></i>
										</button>
										<a href="/cpanel/edit/<?=$product['id'];?>"
												class="btn btn-warning btn-3block"
												title="Редактировать товар">
											<i class="fa fa-pencil"></i>
										</a>
										<button class="btn btn-danger btn-3block"
												onclick="admin.deleteProduct(<?=$product['id'];?>);"
												title="Удалить товар">
											<i class="fa fa-trash"></i>
										</button>
									</div>
								</div>
							</div>
						</div>
						<?php
					}
				}else echo '<center><h3>Нет товаров</h3></center>';
				if ($data['pag'] != '0') {
					?>
					<div class="row">
						<div class="col-md-12">
							<center>
								<ul class="pagination">
									<?=$data['pag'];?>
								</ul>
							</center>
						</div>
					</div>
					<?php
				}
				?>
			</div>
		</div>
	</div>
</div>
<!-- deleteModal -->
<div class="modal fade" id="deleteModal">
	<div class="modal-dialog">
		<div class="col-md-10 col-md-offset-1">
			<div class="modal-content">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal" aria-hidden="true"><i class="fa fa-close"></i></button>
					<h4 class="modal-title">Вы уверены?</h4>
				</div>
				<div class="modal-body">
					<center>
						<h4>Нажимая кнопку удалить, вы безвозвратно сотрете всю информацию о товаре!</h4>
					</center>
					<br>
					<form>
						<input type="hidden" name="api" value="admin">
						<input type="hidden" name="admin" value="delete_product">
						<input type="hidden" name="id" value="none">
						<button class="btn btn-danger btn-block">Удалить</button>
					</form>
				</div>
			</div>
		</div>
	</div>
</div>
